// QRequestHandler.h: interface for the QRequestHandler class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QREQUESTHANDLER_H__35680AA1_AC14_11D2_89E9_D1B8AB62BD1A__INCLUDED_)
#define AFX_QREQUESTHANDLER_H__35680AA1_AC14_11D2_89E9_D1B8AB62BD1A__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Oidtable.h"
#include "QBindManager.h"
#include "QRequest.h"

class QRequestManager  
{
public:
	QRequestManager();
	virtual ~QRequestManager();

public:
  void Poll();

public:
  QRequestID StartRequest( QRequester *requester );
  void FinishRequest( QRequestID req_id );

public:
  void AbortRequest( QRequestID req_id );
  void AbortAll();

public:
  QRequest *GetRequest( QRequestID req_id );

public:
  Oidtable oidtable;

private:
  // Manager for open server connections
  QBindManager bind_mgr;

  // State flags
  BOOL polling;

  // Accumulator used to generate new request identifiers
  QRequestID req_id_acc;

  // Request list
  PtrList<QRequest> request_list;
};

#endif // !defined(AFX_QREQUESTMANAGER_H__35680AA1_AC14_11D2_89E9_D1B8AB62BD1A__INCLUDED_)
